<template>
    <form class="w-100">
        <div class="row">
            <div class="col-12 mb-2">
                <div class="form-group row mb-3">
                    <label class="col-4 col-form-label fw-bold text-black">Telephely</label>
                    <div class="col-8">
                        <Dropdown v-model="extinguisher.premises"
                                  :options="premises" optionLabel="value" optionValue="key"
                                  placeholder="Telephely" class="w-100"
                        />
                    </div>
                </div>
                <div class="form-group row mb-3">
                    <label class="col-4 col-form-label fw-bold text-black">Belső azonosító</label>
                    <div class="col-8">
                        <InputText v-model="extinguisher.identifier" class="w-100" placeholder="belső azonosító"/>
                    </div>
                </div>
                <div class="form-group row mb-3">
                    <label class="col-4 col-form-label fw-bold text-black">Készenléti helye</label>
                    <div class="col-8">
                        <InputText v-model="extinguisher.location" class="w-100" placeholder="készenléti helye"/>
                    </div>
                </div>
                <div class="form-group row mb-3">
                    <label class="col-4 col-form-label fw-bold text-black">Készüléktípus</label>
                    <div class="col-8">
                        <Dropdown v-model="extinguisher.extinguisherType"
                                  :options="types" optionLabel="value" optionValue="key"
                                  placeholder="készüléktípus" class="w-100"
                        />
                    </div>
                </div>
                <div class="form-group row mb-3">
                    <label class="col-4 col-form-label fw-bold text-black">Gyári száma</label>
                    <div class="col-8">
                        <InputText v-model="extinguisher.serialNumber" class="w-100" placeholder="gyári száma"/>
                    </div>
                </div>
                <div class="form-group row mb-3">
                    <label class="col-4 col-form-label fw-bold text-black">Gyártás</label>
                    <div class="col-8">
                        <Dropdown v-model="extinguisher.productionTime.year"
                                  :options="getYears()" optionLabel="value" optionValue="key"
                                  placeholder="Év" class="w-50"
                        />
                        <Dropdown v-model="extinguisher.productionTime.month"
                                  :options="getMonths()" optionLabel="value" optionValue="key"
                                  placeholder="Hónap" class="w-25"
                        />
                        <Dropdown v-model="extinguisher.productionTime.day"
                                  :options="getDays()" optionLabel="value" optionValue="key"
                                  placeholder="Nap" class="w-25"
                        />
                    </div>
                </div>
                <div class="form-group row mb-3">
                    <label class="col-4 col-form-label fw-bold text-black">Megjegyzés</label>
                    <div class="col-8">
                        <Textarea v-model="extinguisher.note" rows="2" class="w-100" placeholder="megjegyzés"/>
                    </div>
                </div>
                <div class="form-group row mb-3" v-if="extinguisher.id === 0">
                    <label class="col-4 col-form-label fw-bold text-black">Többszörösítés</label>
                    <div class="col-8">
                        <Dropdown v-model="extinguisher.clone"
                                  :options="clones()" optionLabel="value" optionValue="key"
                                  placeholder="Többszörösítés" class="w-100"
                        />
                    </div>
                </div>
            </div>
        </div>
    </form>
</template>

<script>
import Dropdown from 'primevue/dropdown';
import InputText from 'primevue/inputtext';
import InputNumber from "primevue/inputnumber";
import Textarea from 'primevue/textarea';
import moment from "moment";
import {ApiService} from "../../services/ApiService";

export default {
    name: "extinguisherForm",
    components: {
        Dropdown,
        InputText,
        InputNumber,
        Textarea
    },
    props: {
        extinguisher: {
            premises: {
                type: Number
            },
            identifier: {
                type: String
            },
            location: {
                type: String
            },
            extinguisherType: {
                type: Number
            },
            serialNumber: {
                type: String
            },
            productionTime: {
                year: {
                    type: Number
                },
                month: {
                    type: Number
                },
                day: {
                    type: Number
                }
            },
            note: {
                type: String
            },
            clone: {
                type: Number
            }
        },
        types: {
            type: Array
        }
    },
    data() {
        return {
            apiService: new ApiService(),
            premises: [
                {
                    key: 1,
                    value: 'PRÓBAFELADAT'
                }
            ]
        }
    },
    methods: {
        getYears() {
            const years = []
            const currentYear = (new Date()).getFullYear();

            for (let i = 1950; i <= currentYear; i++) {
                years.push({
                    key: i,
                    value: i,
                })
            }

            return years.sort(function (a, b) {
                return b.key - a.key
            })
        },
        getMonths() {
            const months = []
            const dateStart = moment()
            const dateEnd = moment().add(12, 'month')

            while (dateEnd.diff(dateStart, 'months') >= 0) {
                months.push({
                    key: parseInt(dateStart.format('M')),
                    value: dateStart.format('M')
                })

                dateStart.add(1, 'month')
            }

            return months.sort(function (a, b) {
                return a.key - b.key
            })
        },
        getDays() {
            const days = []

            for (let i = 1; i <= 31; i++) {
                days.push({
                    key: i,
                    value: i,
                })
            }

            return days
        },
        clones() {
            const clones = []

            for (let i = 2; i <= 10; i++) {
                clones.push({
                    key: i,
                    value: i + ' db',
                })
            }

            return clones
        }
    }
}
</script>

<style scoped>

</style>
